
!ABCNotIncludeFile

! OMIT('_EndOfInclude_', _wPDFViewControlClassPresent_)
!_wPDFViewControlClassPresent_ EQUATE(1)

wPDFViewControl CLASS,TYPE,MODULE('cwPDFViewControl.CLW'),LINK('cwPDFViewControl.CLW',_wPDFViewLinkMode_),DLL(_wPDFViewDLLMode_)
              ! Properties -------------------------------------------------------------------------
hWindow                    LONG
LibHandle                  LONG
Trial                      LONG(FALSE)  
PlusVersion                LONG(FALSE)
PDFViewClassName           CSTRING('WPCubed_PDFVIEW_Demo_01<0>{40}')
PDFViewDllName             CSTRING('wPDFViewDemo02.dll<0>{45}')
!ViewControl Properties  (must be set before init)
wpHorzScrollBar            BYTE(TRUE)
wpVertScrollBar            BYTE(TRUE)
wpPropertyPanel            BYTE(TRUE)
wpNavigationPanel          BYTE(TRUE)
wpViewPanel                BYTE(TRUE)
DllVersion                 SHORT(4)
LoadedFile                 STRING(256)
UseRegionAsParent          BYTE(FALSE)


              ! Methods -------------------------------------------------------------------------
Init                       Procedure(Window W, Short RegionFeq, <String LicenseName>, <String LicenseCode>, <Long LicenseNumber>),LONG,VIRTUAL,Proc
Kill                       Procedure(),VIRTUAL,Proc
LoadFile                   Procedure(<String PDFFile>),LONG,VIRTUAL,Proc
LoadFromBLOB               Procedure(*BLOB PDF_BLOB),LONG,VIRTUAL,Proc
AppendFile                 Procedure(<String PDFFile>),LONG,VIRTUAL,Proc
ClearView                  Procedure(),VIRTUAL
ShowAbout                  Procedure(),VIRTUAL
DocumentProperties         Procedure(),VIRTUAL
SetZoom                    Procedure(LONG ZoomParam),VIRTUAL
DisablePrint               Procedure(LONG PrintParam),VIRTUAL
Resize                     Procedure(LONG RegionFeq),VIRTUAL
FindText                   Procedure(String Text, Byte HighLight = TRUE, Byte FindNext = TRUE, BYTE CaseInsensitive = TRUE, Byte DontGoToPage = false ),LONG,PROC,VIRTUAL
_Print                     Procedure(Byte ShowPrintDialog = TRUE, <Long StartPage>, <Long EndPage>),VIRTUAL
PrintToPrinter             Procedure(STRING pPrinterName, <Long StartPage>, <Long EndPage>),VIRTUAL
PreviewFile                Procedure(String PDFFile, <String LicenseName>, <String LicenseCode>, <Long LicenseNumber>),VIRTUAL,Proc
SetViewControlProperties   Procedure(),VIRTUAL
!Info Messages
GetPageCount               Procedure(),LONG,VIRTUAL
GetTextLength              Procedure(<LONG PageNo>),LONG,VIRTUAL
GetText                    Procedure(*STRING TextBuffer, <LONG PageNo>),VIRTUAL
Command                    Procedure(LONG CommandID, LONG CommandParam),LONG, VIRTUAL,PROC
CommandStr                 Procedure(LONG CommandID, STRING CommandParam),LONG, VIRTUAL,PROC     
CommandStrEx               Procedure(LONG CommandID, STRING CommandParam, LONG Param),LONG, VIRTUAL,PROC
pdfPrint                   Procedure( STRING strFilenames,STRING strPassword, STRING strLicName, STRING strLicKey, LONG lngLicCode, STRING strOptions),LONG,PROC,VIRTUAL
pdfMakeJPEG                Procedure( STRING strFilenames,STRING strPassword, STRING strLicName, STRING strLicKey, LONG lngLicCode, STRING strDestPath, LONG frompage, LONG to_page, LONG jpegres),LONG,PROC,VIRTUAL
               END

!Equates
COMPDF_DocumentProperties EQUATE(1)  ! Show document property window
COMPDF_SecurityProperties EQUATE(2)  ! Show document security property window (RESERVED)
COMPDF_RightProperties    EQUATE(3)  ! Show rights property window (only edit mode!)
COMPDF_FontProperties     EQUATE(4)  ! Show font property window (RESERVED)
COMPDF_ViewPreferences    EQUATE(5)  ! Show Viewer Preferences
COMPDF_ShowAbout          EQUATE(6)  ! Show Viewer/Editor About Dialog
COMPDF_EditPreferences    EQUATE(7)  ! Show Editor Preferences  (RESERVED)

        ! Window Popup
COMPDF_GotoFirst          EQUATE(20) ! Goto first page
COMPDF_GotoPrev           EQUATE(21) ! Goto Previous page
COMPDF_GotoPage           EQUATE(22) ! Goto Page Nr in parameter
COMPDF_GotoNext           EQUATE(23) ! Goto next page
COMPDF_GotoLast           EQUATE(24) ! Goto last page
COMPDF_ShowGotoPage       EQUATE(25) ! Show page nr editfield (RESERVED)
COMPDF_ShowGotoBookmark   EQUATE(26) ! Show bookmark edit (RESERVED)
COMPDF_GotoYPos           EQUATE(27) ! Goto 'A' as y in 72 dpi
COMPDF_GotoXPos           EQUATE(28) ! Goto 'B' as x in 72 dpi
COMPDF_ScrollXY           EQUATE(29) ! Bit 1: Horz, Bit 2: Large, Bit 3=Next

        ! Print
COMPDF_PrinterSetup       EQUATE(30) ! Setup Printer Dialog
COMPDF_Print              EQUATE(31) ! Print Document (string=range or Low(B)=from, High(B)=to)
COMPDF_PrintDialog        EQUATE(32) ! Show Print Dialog

COMPDF_SelectPrinter        EQUATE(35) ! par=printer name
COMPDF_BeginPrint           EQUATE(36) ! Start Print Job
COMPDF_EndPrint             EQUATE(37) ! End Print Job
COMPDF_SelectPrinterBin0    EQUATE(38) ! PrinterBin Def for default
COMPDF_SelectPrinterBin1    EQUATE(39) ! PrinterBin Def for primary
COMPDF_SelectPrinterBin2    EQUATE(40) ! PrinterBin Def for secondary

        ! Zoom Commands
COMPDF_Zoom100              EQUATE(41) ! 100 % Zoom
COMPDF_ZoomIn               EQUATE(42) !  + 10%
COMPDF_Zoom                 EQUATE(43) ! Zoom to StrPar/IntPar - if IntPar=0 retrieve zoom! If StrPar<>'' the set to zooming mode
COMPDF_ZoomOut              EQUATE(44) !  - 10%
COMPDF_ZoomFullWidth        EQUATE(45) ! Page Width
COMPDF_ZoomFullPage         EQUATE(46) ! Page Width
COMPDF_ZoomTwoPages         EQUATE(47) ! Toggle 2 Pages Display

        ! Customization
COMPDF_SelectControls       EQUATE(50) ! Select which buttons to see: 1=VScroll, 2=HScroll, 4=ViewPanel, 8=SearchPanel, 16=OptionButton
COMPDF_SelectOptions        EQUATE(51) ! 1EQUATE(wpDontUseHyperlinks, 2EQUATE(wpDontHighlightLinks,
        ! 4=wpDontAskPassword, 8=wpSelectClickedPage, 16=wpShowCurrentPage

        ! Modify Strings in menu
COMPDF_SetDocumentProperties EQUATE(61)  ! Str param EQUATE(new text, "" to switch off
COMPDF_SetSecurityProperties EQUATE(62)  !(RESERVED)
COMPDF_SetRightProperties   EQUATE(63)  !(RESERVED)
COMPDF_SetFontProperties    EQUATE(64)  !(RESERVED)
COMPDF_SetViewPreferences   EQUATE(65)  !(RESERVED)
COMPDF_SetShowAbout         EQUATE(66)
COMPDF_SetEditPreferences   EQUATE(67)  !(RESERVED)
COMPDF_SetPrintSetup        EQUATE(68)
COMPDF_SetPrint             EQUATE(69)  
COMPDF_SetExViewOptions     EQUATE(81)

        ! File Commands
COMPDF_Clear                EQUATE(100) ! Clears the viewer
COMPDF_Load                 EQUATE(101) ! Load PDF file par
COMPDF_Append               EQUATE(102) ! Append PDF file par
COMPDF_AppendHGlobal        EQUATE(103) ! par EQUATE(HGLOBAL
COMPDF_AppendIStream        EQUATE(104) ! par EQUATE(IStream interface pointer (for use with COM)
COMPDF_AppendEStream        EQUATE(105) ! par EQUATE( EventStream Record Ptr - create copy
COMPDF_AppendEPStream       EQUATE(106) ! par EQUATE( EventStream Record Ptr - use that (attach!)

        ! Security Commands
COMPDF_SetLoadPassword      EQUATE(120) ! Sets master load password (also in NeedPassword event!)
COMPDF_ClearPasswords       EQUATE(121) ! Clears the list of passwords
COMPDF_AddPassword          EQUATE(122) ! Adds a password to the list

        ! Disable Functionality (once sent to the control it cannot be changed anymore)
COMPDF_DisablePrint         EQUATE(123) ! Disable print - it is not possible to enable again!
COMPDF_DisableHQPrint       EQUATE(124) ! Disable high quality print - if print, only low quality!
COMPDF_DisableSelectPrinter EQUATE(125) ! Disable Select Printer or PrintDialog (print at once!)
COMPDF_DisablePrintHDC      EQUATE(126) ! Disable print to HDC - it is not possible to enable again!
        ! functionality reserved for future - but automatically executed by present version
COMPDF_DisableSave          EQUATE(127) ! Disable saving of the PDF file - it is not possible to enable again!
COMPDF_DisableCopy          EQUATE(128) ! Disable copy to clipboard - it is not possible to enable again!
COMPDF_DisableForms         EQUATE(129) ! Disable form editing - it is not possible to enable again!
COMPDF_DisableEdit          EQUATE(130) ! Disable editing - it is not possible to enable again!
COMPDF_DisableSecurityOverride EQUATE(131) ! By standard the viewer does not respect the P flag. With this setting it does
COMPDF_ShowNavigation          EQUATE(134)

        ! Print HDC Commands
COMPDF_PrintHDC             EQUATE(150) ! disabled in DEMO! B=PageNO
COMPDF_PrintHDCSetHDC      EQUATE(151) ! Set HDC for the next COMPDF_PrintHDC
COMPDF_PrintHDCSetXRes     EQUATE(152) ! Set X Resolution for the next COMPDF_PrintHDC
COMPDF_PrintHDCSetYRes     EQUATE(153) ! Set Y Resolution for the next COMPDF_PrintHDC
COMPDF_PrintHDCUseCurves   EQUATE(154) ! if par<>0 print all text is printed as curves

        ! Read Commands
COMPDF_GetPageCount       EQUATE(201) ! get count of loaded pages
COMPDF_GetViewPage        EQUATE(202) ! get current page
COMPDF_GetPageWidth       EQUATE(203) ! IntPar EQUATE(pageno
COMPDF_GetPageHeight      EQUATE(204) ! IntPar EQUATE(pageno
COMPDF_GetPageRotation    EQUATE(205) ! IntPar EQUATE(pageno
COMPDF_GetYPos            EQUATE(210) ! Get Scroll Y Pos in 72 dpi
COMPDF_GetXPos            EQUATE(211) ! Get Scroll x Pos in 72 dpi
COMPDF_GetWidth           EQUATE(212) ! Get Window width in 72 dpi
COMPDF_GetHeight          EQUATE(213) ! Get Window height in 72 dpi
COMPDF_GetPageUnderMouse  EQUATE(214) ! Page under current Mouse position (for popup menues!)
 
        ! Set Page Info (UpdatePageDimension)
COMPDF_SetPageWidth         EQUATE(230) ! Set Width of selected pages in 72 dpi
COMPDF_SetPageHeight        EQUATE(231) ! Set Height of selected pages  in 72 dpi
COMPDF_SetPageRotation      EQUATE(233) ! Absolute: 1..4 or relative +-90
COMPDF_SetPagePaperBin      EQUATE(234) ! Sets Paperbin for selected pages

        ! Page Selection
COMPDF_PageSelectionClear   EQUATE(248) ! Removes previous selection
COMPDF_PageSelectionAdd     EQUATE(249) ! Select one additional page
COMPDF_PageSelectionDel     EQUATE(250) ! Removes Selection from Page
COMPDF_PageSelectionInvert  EQUATE(251) ! Inverts Selection
  ! Find Text
COMPDF_FindAltText          EQUATE(252) ! Pass the wide string which should be found alternatively
COMPDF_FindGotoPage         EQUATE(253) ! Mode: 1-> Goto Page (default), 1 don't go
COMPDF_FindCaseInsitive     EQUATE(254) ! Mode: 1-> Case sensitive (default), 1 insensitive(use COMPDF_FindAltText!!!)
COMPDF_FindText             EQUATE(255) ! Finds from page 0
COMPDF_FindNext             EQUATE(256) ! Finds from corrent page +1
COMPDF_HighlightText        EQUATE(257) ! Highlights the text

! GetText
COMPDF_GetTextLen           EQUATE(260) ! Result = buffer len
COMPDF_GetTextBuf           EQUATE(261) ! Copy to PChar (must be correct len!)

        ! Field Commands
COMPDF_Field_InputChar      EQUATE(301) ! Insert Char into active Field
COMPDF_Field_InputKey       EQUATE(302) ! use VKCode for active Field. High EQUATE(ShiftCode
COMPDF_Field_Set            EQUATE(303) ! Set the active field to StrPar
COMPDF_Field_MoveNext       EQUATE(304) ! Move to next field
COMPDF_Field_MovePrevious   EQUATE(305) ! Move to previous field
COMPDF_Field_Move           EQUATE(306) ! Move to field with name 'StrParam' or IntPar=Nr-1
COMPDF_SaveToFile           EQUATE(501)

        ! EVENT - SET RESULT (Can be used to modify result in VAR events)
COMPDF_SetResultA           EQUATE(2001) ! IntPar  =Value A
COMPDF_SetResultB           EQUATE(2002) ! IntPar  =Value B

        ! Message ID to send data to PDF Viewer
WM_PDF_COMMANDSTR           EQUATE(0400h + 77) ! wparam  =command, lparam  =PChar,
WM_PDF_EVENT                EQUATE(0400h + 78) ! wParam  =nr, lparam  =par
WM_PDF_COMMAND              EQUATE(0400h + 79) ! wparam  =command, lparam  =B
WM_PDF_ENABLE               EQUATE(0400h + 80) ! switches control into active mode
WM_PDF_COMMANDSTRU          EQUATE(0400h + 81) ! wparam  =command, lparam  =*widestring,
WM_PDF_INTERNEVENT          EQUATE(0400h + 82) ! used by viewer

        ! Event IDS
MSGPDF_NEEDPASSWORD         EQUATE(100) ! Set a new password!
MSGPDF_PROBLEMONLOAD        EQUATE(101) ! We have a probelm while loading the file
MSGPDF_PROBLEMONDISPLAY     EQUATE(102) ! We have a probelm while displaying the file
MSGPDF_INITCOMMANDS         EQUATE(103) ! Set the command offsets (lparam)
MSGPDF_CHANGEVIEWPAGE       EQUATE(104) ! Moved to different page (=wparam)
MSGPDF_SETVERSION           EQUATE(105) ! lparam  = version * 1000
MSGPDF_INITMASTERKEY        EQUATE(106) ! Set RSA Masterkey (NOTIMPL)
MSGPDF_INTERNEXCEPTION      EQUATE(107) ! Send exception string
MSGPDF_CHANGESELPAGE        EQUATE(108) ! Moved to different page (=wparam)

        !GUI Events
MSGPDF_KEYDOWN           EQUATE(201) ! l Param  = Key, SetResult with
MSGPDF_KEYPRESS          EQUATE(202) ! l Param  = Key
MSGPDF_KEYUP             EQUATE(203) ! l Param  = Key



!_EndOfInclude_

